#Region "Imports Directives"
Imports System
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Web
Imports Microsoft.Web.Administration
#End Region

Namespace CodeMonkey
    '-----------------------------------------------------------------------------------'
    ' Handler to Add Copyright statement to all jpgs served                             '
    '                                                                                   '
    ' Implements the IHttpHandler Interface                                             '
    '                                                                                   '
    '-----------------------------------------------------------------------------------'
    Public Class imageCopyrightHandler
        Implements IHttpHandler
        Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
            Get
                Return True
            End Get
        End Property
        Public Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
            Dim imageCopyrightHandlerSection As ConfigurationSection = WebConfigurationManager.GetSection("system.webServer/imageCopyright")

            HandleImage(context, CType(imageCopyrightHandlerSection.GetAttribute("enabled").Value, Boolean), CType(imageCopyrightHandlerSection.GetAttribute("message").Value, String), CType(imageCopyrightHandlerSection.GetAttribute("color").Value, String))

        End Sub
        Sub HandleImage(ByVal context As HttpContext, ByVal enabled As Boolean, ByVal message As String, ByVal color As String)
            Try
                Dim strPath As String = context.Request.PhysicalPath
                If enabled Then
                    Dim bitmap As Bitmap = New Bitmap(strPath)

                    'add copyright message
                    Dim g As Graphics = Graphics.FromImage(bitmap)
                    Dim f As Font = New Font("Tahoma", 40, GraphicsUnit.Pixel)
                    Dim sb As SolidBrush = New SolidBrush(System.Drawing.Color.FromName(color))
                    g.DrawString(message, f, sb, 5, bitmap.Height - f.Height - 5)
                    f.Dispose()
                    g.Dispose()

                    context.Response.ContentType = "image/jpeg"
                    bitmap.Save(context.Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg)
                    bitmap.Dispose()
                Else
                    context.Response.WriteFile(strPath)
                End If
            Catch ex As Exception
                context.Response.Write(ex.Message)
            End Try
        End Sub
    End Class
End Namespace
