Imports System
Imports System.Collections.Generic
Imports System.Windows.Forms
Imports Microsoft.Web.Management.Client.Win32
Imports Microsoft.Web.Administration
Imports Microsoft.Web.Management.Client
Imports Microsoft.Web.Management.Server
Public NotInheritable Class imageCopyrightUIPage
    Inherits ModulePage
    Public message As String
    Public featureenabled As Boolean
    Public color As String
    Dim _colCombo As New ComboBox
    Dim _msgTB As New TextBox
    Dim _enabledCB As New CheckBox

    Sub New()
        Me.Initialize()
    End Sub

    Protected Overrides Sub OnActivated(ByVal initialActivation As Boolean)
        MyBase.OnActivated(initialActivation)

        If initialActivation Then
            ReadConfig()
            UpdateUI()
        End If
    End Sub
    Sub UpdateUI()
        _enabledCB.Checked = featureenabled
        Dim n As Integer = _colCombo.FindString(color, 0)
        _colCombo.SelectedIndex = n
        _msgTB.Text = message
    End Sub
    Sub Initialize()
        Dim crLabel As New Label()
        crLabel.Left = 50
        crLabel.Top = 100
        crLabel.AutoSize = True
        crLabel.Text = "Enable Image Copyright:"

        _enabledCB.Text = ""
        _enabledCB.Left = 200
        _enabledCB.Top = 100
        _enabledCB.AutoSize = True


        Dim msglabel As New Label()
        msglabel.Left = 150
        msglabel.Top = 130
        msglabel.AutoSize = True
        msglabel.Text = "Message:"

        _msgTB.Left = 200
        _msgTB.Top = 130
        _msgTB.Width = 200
        _msgTB.Height = 50

        Dim collabel As New Label()
        collabel.Left = 160
        collabel.Top = 160
        collabel.AutoSize = True
        collabel.Text = "Color:"

        _colCombo.Left = 200
        _colCombo.Top = 160
        _colCombo.Width = 100
        _colCombo.Height = 90

        Dim ColorChoice As Drawing.Color = New Drawing.Color
        Dim t As Type = ColorChoice.GetType()
        Dim p As System.Reflection.PropertyInfo
        For Each p In t.GetProperties()
            _colCombo.Items.Add(CType(p.Name, Object))
        Next

        '_colCombo.Items.Add(CType("Yellow", Object))
        '_colCombo.Items.Add(CType("Blue", Object))
        '_colCombo.Items.Add(CType("Red", Object))
        '_colCombo.Items.Add(CType("White", Object))

        Dim apply As New Button()
        apply.Text = "Apply"
        AddHandler apply.Click, AddressOf Me.applyClick
        apply.Left = 200
        apply.AutoSize = True
        apply.Top = 250


        Controls.Add(crLabel)
        Controls.Add(_enabledCB)
        Controls.Add(collabel)
        Controls.Add(_colCombo)
        Controls.Add(msglabel)
        Controls.Add(_msgTB)
        Controls.Add(apply)

    End Sub
    Private Sub applyClick(ByVal sender As Object, ByVal e As EventArgs)
        Try
            UpdateVariables()
            Dim mgr As ServerManager
            Dim section As ConfigurationSection
            mgr = New ServerManager()
            Dim config As Configuration = mgr.GetWebConfiguration(Connection.ConfigurationPath.SiteName, Connection.ConfigurationPath.ApplicationPath + Connection.ConfigurationPath.FolderPath)
            section = config.GetSection("system.webServer/imageCopyright")

            section.GetAttribute("color").Value = CType(color, Object)
            section.GetAttribute("message").Value = CType(message, Object)
            section.GetAttribute("enabled").Value = CType(featureenabled, Object)
            mgr.CommitChanges()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub UpdateVariables()
        featureenabled = _enabledCB.Checked
        color = _colCombo.Text
        message = _msgTB.Text
    End Sub
    Public Sub ReadConfig()
        Try
            Dim mgr As ServerManager
            Dim section As ConfigurationSection
            mgr = New ServerManager
            Dim config As Configuration = mgr.GetWebConfiguration(Connection.ConfigurationPath.SiteName, Connection.ConfigurationPath.ApplicationPath + Connection.ConfigurationPath.FolderPath)

            section = config.GetSection("system.webServer/imageCopyright")

            color = CType(section.GetAttribute("color").Value, String)
            message = CType(section.GetAttribute("message").Value, String)
            featureenabled = CType(section.GetAttribute("enabled").Value, Boolean)
        Catch ex As Exception

        End Try
    End Sub
End Class